#include "tnlib.h"
#pragma hdrstop
#include "tnstr.h"
#include "defs.h"
#include "pdstrlib.h"
//#include "jtype.h"

/*======================================================================//
//	itocs()
//----------------------------------------------------------------------//
// Description:
//	unsigned l10i(RJ}t
//	textɃobt@AhX
//	߂l͕ϊꂽ̐擪̈ʒu
//	obt@20oCgȏł邱
// Arguments:
//
// Return Value:
//	Rs[̐擪AhX
//======================================================================*/
tchar *itocs( int val, tchar *text )
{
	int c = 0;
	text += 19;
	*text-- = '\0';
	bool sign;
	if (val<0){
		sign = true;
		val = -val;
	} else {
		sign = false;
	}
	while ( val != 0 ){
		if ( (c % 3 == 0) && c != 0 ){
			*text-- = ',';
		}
		*text = (tchar)((val % 10)+'0');
		val = val / 10;
		text--;
		c++;
	}
	if ( c == 0 ) *text-- = '0';
	else if (sign) *text-- = '-';
	return text+1;
}
#if 0	// ̂ƂKvȂ̂comment out
tchar *utocs( unsigned val, tchar *text )
{
	int c = 0;
	text += 19;
	*text-- = '\0';
	while ( val != 0 ){
		if ( (c % 3 == 0) && c != 0 ){
			*text-- = ',';
		}
		*text = (tchar)((val % 10)+'0');
		val = val / 10;
		text--;
		c++;
	}
	if ( c == 0 ) *text-- = '0';
	return text+1;
}
#endif
tnstr itocs(int val)
{
	tchar buf[20];
	return itocs(val, buf);
}
// text should be more than 40 bytes.
tchar *itocs64(__int64 val, tchar *text)
{
	int c = 0;
//	tchar *text = buf+tsizeof(buf)-1;
	text += 39;
	*text-- = '\0';
	while ( val != 0 ){
		if ( (c % 3 == 0) && c != 0 ){
			*text-- = ',';
		}
		*text = (tchar)((val % 10)+'0');
		val /= 10;
		text--;
		c++;
	}
	if ( c == 0 ) *text-- = '0';
	return text+1;
}
tnstr itocs64(__int64 val)
{
	tchar buf[40];
	return itocs64(val, buf);
}
#if 0
int atox( const tchar *str, tchar **next )
{
	unsigned val = 0;
	while ( 1 )
	{
		tuchar c = (tuchar)__totupper( *str );
		if ( c >= '0' && c <= '9' ){
			val = (val<<4) + (c - '0');
		} else if ( c >= 'A' && c <= 'F' ){
			val = (val<<4) + ( c - 'A' + 10 );
		} else {
			break;
		}
		str++;
	}
	if ( next ) *next = (tchar*)str;
	return val;
}
#endif
const tchar *skiptospc(const tchar *str)
{
	while (!(*(tuchar*)str<=' ')) str++;
	return str;
}

tchar getlastchar(const tchar *str)
{
	tchar c = 0;
	for (;*str;){
		c = *str++;
	}
	return c;
}

// strlenȓpatƈv镶T
const tchar *_tcsnstr(const tchar *str, const tchar *pat, int len)
{
	int patlen = _tcslen(pat);
	const tchar *end = str + len - patlen + 1;
	while (str<end){
		if (memcmp(str, pat, patlen)==0){
			return str;
		}
		str++;
	}
	return NULL;
}


// from wpdcom.cpp
// Œ菬_Œ菬_ɕϊ
// digit : _ȉ̌
int atofp( const tchar *str, int digit )
{
	if (!str)
		return 0;
	int val = 0;
	bool inpoint = false;	// _ȉ̌vZH
	for(;*str;){
		tchar c = *str++;
		if ( c >= '0' && c <= '9' ){
			val = val * 10 + (c-'0');
			if (inpoint){
				digit--;
				if (digit==0)
					break;
			}
		} else
		if ( c == '.' ){
			if (inpoint)
				break;	// d̏_
			inpoint = true;
		} else {
			break;
		}
	}
	// c̏_t
	for(;digit>0;digit--){
		val *= 10;
	}
	return val;
}
// binbyteshexɕϊ
// ߂ldelete[]邱
tchar *BinToHex( const byte *bin, int bytes )
{
	tchar *buffer = new tchar[(bytes<<1)+1];
	tchar *dp = buffer;
	for (int i=0;i<bytes<<1;i++){
		byte c = bin[i>>1];
		if (!(i&1)) c>>=4;
		c &= 0xF;
		if (c>=0xA){
			*dp++ = c-0xA+'a';
		} else {
			*dp++ = c+'0';
		}
	}
	*dp = '\0';
	return buffer;
}
#if 0
// binbyteshexɕϊ
tnstr bintohex( const byte *bin, int bytes )
{
	autoptr<tchar> s(BinToHex(bin, bytes));
	return tnstr(s);
}
#endif
// str̒ target Ɉv镶񂪂ꍇAnewstringɒu
bool ReplaceString( tchar *str, const tchar *target, const tchar *newstring )
{
	tchar *p = _tcsstr( str, target );
	if ( p ){
		int s1 = _tcslen( target );
		int s2 = _tcslen( newstring );
		memmove( p+s2, p+s1, LENTOBYTE(_tcslen(p+s1)+1) );
		return true;
	}
	return false;
}

tnstr replace(const tchar *str, const tchar *pat, const tchar *sub)
{
	tnstr ret;
	while (*str){
		const tchar *p = _tcsstr(str, pat);
		if (!p){
			ret += str;
			break;
		}
		ret.cat(str, STR_DIFF(p, str));
		ret += sub;
		str = p + _tcslen(pat);
	}
	return ret;
}

#ifndef SMALL
// %xxɕϊ
void EscapeString( const tchar *str1, tnstr &str2 )
{
	tchar *buf = new tchar[ _tcslen(str1) * 3 + 1 ];
	tchar *dp = buf;
	for(;;){
		tuchar c = (tuchar)*str1++;
		if (!c)
			break;
		if (isalnum(c)){
			*dp++ = c;
		} else {
			*dp++ = '%';
			*dp++ = (c>>4)>=0xA ? (c>>4)+'A'-0xA : (c>>4) + '0';
			*dp++ = (c&0xF)>=0xA ? (c&0xF)+'A'-0xA : (c&0xF) + '0';
		}
	}
	*dp = '\0';
	str2.setBuf( buf );
}
// URIescapeȂ΂ȂȂflag, etc..
static char uriescape[] = {
	// 0x20
	1, 0, 1, 1, 1, 1, 1, 0,
	0, 0, 0, 1, 1, 0, 0, 1,
	// 0x30
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 1, 1, 1, 1, 1, 1,
	// 0x40
	1, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	// 0x50
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 1, 1, 1, 1, 0,
	// 0x60
	1, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	// 0x70
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 1, 1, 1, 0, 1
};
// %xxɕϊ
void EscapeURIString( const tchar *str1, tnstr &str2 )
{
	tchar *buf = new tchar[ _tcslen(str1) * 3 + 1 ];
	tchar *dp = buf;
	for(;;){
		tuchar c = (tuchar)*str1++;
		if (!c)
			break;
		if (c>=0x20 && c<=0x7F){
			if (uriescape[c-0x20]&1){
				// escape char
			} else {
				*dp++ = c;
				continue;
			}
		}
		*dp++ = '%';
		*dp++ = (c>>4)>=0xA ? (c>>4)+'A'-0xA : (c>>4) + '0';
		*dp++ = (c&0xF)>=0xA ? (c&0xF)+'A'-0xA : (c&0xF) + '0';
	}
	*dp = '\0';
	str2.setBuf( buf );
}
void EscapeURIString( const char *str1, tnstrA &str2 )
{
	char *buf = new char[ strlen(str1) * 3 + 1 ];
	char *dp = buf;
	for(;;){
		unsigned char c = (unsigned char)*str1++;
		if (!c)
			break;
		if (c>=0x20 && c<=0x7F){
			if (uriescape[c-0x20]&1){
				// escape char
			} else {
				*dp++ = c;
				continue;
			}
		}
		*dp++ = '%';
		*dp++ = (c>>4)>=0xA ? (c>>4)+'A'-0xA : (c>>4) + '0';
		*dp++ = (c&0xF)>=0xA ? (c&0xF)+'A'-0xA : (c&0xF) + '0';
	}
	*dp = '\0';
	str2.setBuf( buf );
}
#endif
// sR[hcrlfɓꂷ
// str : ϊ
// buf : ϊ
void NormalizeCRLF( const tchar *str, tchar *buf, const tchar *crlf )
{
	const tchar *cp;
	
	for(;;str++){
		switch (*str){
			case '\0':
				*buf = '\0';
				goto jend;
			case '\r':
				if (str[1]!='\n')
					goto jchange;	// '\r'̂
				continue;	// ignore
			case '\n':
		jchange:;
				cp = crlf;
				for(;*cp;) *buf++ = *cp++;
				continue;
			default:
				*buf++ = *str;
				break;
		}
	}
jend:;
}


static int is_html_digit(const tchar *s)
{
	int n = -1;

	for (;*s;){
		if (*s>='0' && *s<='9'){
			if (n==-1)
				n = 0;
			n = n*10 + *s-'0';
			s++;
			continue;
		}
		if (*s!=';'){
			n = -1;
		}
		break;
	}
	return n;
}

static const tchar *unesc_html(tnstrbuf &b, const tchar *s)
{
	int n;

	if (!_tcsncmp(s, _t("lt;"), 3)){
		b += '<';
		return s+3;
	} else
	if (!_tcsncmp(s, _t("gt;"), 3)){
		b += '>';
		return s+3;
	} else
	if (!_tcsncmp(s, _t("amp;"), 4)){
		b += '&';
		return s+4;
	} else
	if (!_tcsncmp(s, _t("quot;"), 5)){
		b += '"';
		return s+5;
	} else
	if (!_tcsncmp(s, _t("nbsp;"), 5)){
		b += ' ';
		return s+5;
	} else
	if (s[0]=='#' && (n=is_html_digit(s+1))!=-1){
		b += (tchar)n;
		return _tcschr(s+2, ';') + 1;
	}
	return NULL;
}

tnstr UnescapeHtml(const tchar *text, int len)
{
	tnstrbuf b;
	const tchar *end = len<0?(const tchar*)-1:text+len;
	while (text<end && *text){
		if (*text=='&'){
			const tchar *p = unesc_html(b, text+1);
			if (p){
				text = p;
				continue;
			}
		}
		b += *text++;
	}
	return tnstr(b);
}

