#ifndef	__FILESTR_H
#define	__FILESTR_H

bool makename( tnstr &fullpath, const tchar *path, const tchar *filename );
void get_filename( const tchar *path, tchar *filename );
tchar *GetWildPtr( const tchar *path );
void addyen( tchar *path );
tnstr AddYen(const tchar *path);
tchar *GetFileName( const tchar *path );
inline tchar *GetBaseName(const tchar *path)
	{ return GetFileName(path); }
tchar *GetFileName1( const tchar *path );
// gq̈ʒu𓾂
// . ̎̃AhXԂ
// Ȃ NULLԂ
// . ŏIt@CłNULLłȂ̂ŒӁI
tchar *GetFileExtension( const tchar *filename );	// gq̈ʒu𓾂
tchar *GetFileExt(const tchar *filename);
bool IsFullPath( const tchar *filename );
bool IsSameFile( const tchar *file1, const tchar *file2 );
bool IsSameFile( tnstr_vec &name1, const tchar *name2 );
bool IsSameFileName(const tchar *file1, const tchar *file2);

#ifdef _Windows
void AbsToRel( tnstr &name );
void RelToAbs( tnstr &in, tnstr &out );
#else
#define	AbsToRel( name )
#define	RelToAbs( name1, name2 )
#endif

tnstr MakeRelativeDrive(const tchar *path1, const tchar *path2);
tnstr MakeRelativePath(const tchar *path1, const tchar *path2);

void ChangeFileExtension(tnstr &filename, const tchar *ext);
inline void ChangeFileExt(tnstr &filename, const tchar *ext)
	{ ChangeFileExtension(filename, ext); }

void ChangePath( tnstr &newfilename, const tchar *filename, const tchar *newpath );

tnstr _GetFilePath( const tchar *filename );
tnstr GetTempPath();
tnstr MakePath(const tchar *path, const tchar *filename);
bool MkDir(const tchar *dir);

#endif	// __FILESTR_H

